'////////////////////////////////////////////////////////////////////
'///  DDS Function generator 0.1 Hz - 1250 kHz, resolution 0.1 Hz  ///
'////////////////////////////////////////////////////////////////////
$regfile = "m48def.dat"
Const Fosc = 7380000
$crystal = Fosc                                   ' adjust for used crystal
$baud = 115200
$hwstack = 32
$swstack = 32
$framesize = 32
Declare Sub Gensquare()
Declare Sub Calcload()

'Config Serialin0 = Buffered , Size = 10 , Bytematch = 10

Dim Mload_r As Iram Long At 12 Overlay
Dim Phase As Iram Long At 26 Overlay

Dim Freq As Long
Dim Mloads As Single
Dim Mload As Long

Const Wide = 2 ^ 32
Const L = 7
Const Frmul =(wide / Fosc) * L

Ddrb = &HFF
Ddrd = &B10010010
Freq = 2002
Print "Press ANYKEY"
On Urxc Ser_isr

Enable Urxc
Enable Interrupts

Call Calcload
Call Gensquare()

Sub Calcload()
Mloads = Freq * Frmul
'Mloads = Mloads / 10
Mload = Mloads
End Sub

Sub Gensquare()
 Phase = 0
 Mload_r = Mload

Sqrs:
 add  r26,r12   ; 1
 Adc  r27,r13   ; 1
 Adc  r28,r14   ; 1
 Adc  r29,r15   ; 1
 !out  PORTB,r29  ; 1
 rjmp Sqrs   ; 2  = 7
End Sub
Ser_isr:
Serial0charmatch:
   Input "Enter desired Feq>", Freq                                   ', Noecho
'   Clear Serialin
   Call Calcload
   Mload_r = Mload
   Print "Press ANYKEY"
Return

End